## ksh 93u%2B

=== debian/changelog ===
ksh (93u+-1.2) testing-proposed-updates; urgency=low

  * Non-maintainer upload.
  * Fix handling of cd ../../.. and similar using
    the upstream changes from ee4582a commit, drop previous patch
    by Jonathan Wiltshire <jmw@debian.org> (Closes: #679966).

 -- John Paul Adrian Glaubitz <glaubitz@physik.fu-berlin.de>  Wed, 02 Jan 2013 18:41:22 +0100

ksh (93u+-1.1) testing-proposed-updates; urgency=low

  * Non-maintainer upload.
  * Fix handling of cd ../../.. and similar
    (cddotdot.patch, Closes: #679966)

 -- Jonathan Wiltshire <jmw@debian.org>  Sat, 13 Oct 2012 22:53:44 +0100

ksh (93u+-1) unstable; urgency=low

  * Bump to Standards-Version 3.9.3
  * New upstream release (closes: #636580, #667038)

 -- Oliver Kiddle <okiddle@yahoo.co.uk>  Sun, 15 Apr 2012 01:28:31 +0200

## ksh 93u%2B20120801

=== debian/control ===
Source: ksh
Section: shells
Priority: optional
Maintainer: Nicholas Bamber <nicholas@periapt.co.uk>
Homepage: http://www.kornshell.com/
Build-Depends: dpkg-dev (>= 1.16.1), debhelper (>= 9)
Standards-Version: 3.9.6
Vcs-Git: https://salsa.debian.org/debian/ksh.git
Vcs-Browser: https://salsa.debian.org/debian/ksh

Package: ksh
Architecture: any
Depends: ${shlibs:Depends}, ${misc:Depends}, binfmt-support
Description: Real, AT&T version of the Korn shell
 Ksh is a UNIX command interpreter (shell) that is intended for both
 interactive and shell script use. Its command language is a superset of
 the sh(1) shell language.
 .
 The 1993 version adds a number of new, mostly scripting related,
 features over the 1988 version that is typically distributed with
 commercial UNIX variants. For example, it has lexical scoping, compound
 variables, associative arrays, named references and floating point
 math.
 .
 The shcomp tool can be used to compile ksh scripts into a binary format.

## ksh 93u+

=== src/cmd/INIT/Makefile ===
/*
 * initialization for all packages
 */

:PACKAGE: license=ast

LICENSE = since=1994,author=gsf

PACKAGEROOT = $(INSTALLROOT:T=F:P=L*:O=n)

hurl :: hurl.sh LICENSE=since=2003,author=gsf

iffe :: iffe.sh LICENSE=since=1994,author=gsf+kpv

mktest :: mktest.sh LICENSE=since=2005,author=gsf

package :: package.sh

regress :: regress.sh LICENSE=since=1995,author=gsf

rt :: rt.sh LICENSE=since=2005,author=gsf

$(PACKAGEROOT)/bin :INSTALLDIR: execrate ignore mamprobe package silent

crossexec :: crossexec.sh

ditto :: ditto.sh LICENSE=since=2001,author=gsf+ek

execrate :: execrate.sh LICENSE=since=2002,author=gsf

filter :: filter.sh

ignore :: ignore.sh

silent :: silent.sh

$(PACKAGEROOT)/lib/package :INSTALLDIR: package.mk CONVERT.mk

$(LIBDIR)/make :INSTALLDIR: package.mk PROBE.mk TEST.mk WWW.mk \
	MSGFUN.mk MSGKEY.mk MAPLIB.mk

:TEST: iffe mamake

cc ld ldd :PACKAGE_INIT: mamake.c proto.c ratz.c release.c

:: RELEASE hosttype.tst p.c hello.c \
	ar.ibm.risc \
	cc.specialize cc.pentium4 \
	ldd.cygwin.i386 \
	cc.darwin.i386 cc.darwin.i386-64 cc.darwin ldd.darwin \
	cc.hp.ia64 cc.hp.pa cc.hp.pa64 ld.hp.pa ldd.hp.pa \
	cc.ibm.risc cc.ibm.risc.gcc ldd.ibm.risc \
	cc.linux.ia64-icc cc.linux.i386-icc cc.linux.i386-64-icc \
	cc.lynxos.i386 cc.lynxos.ppc ldd.lynxos \
	cc.mvs.390 cc.next.i386 cc.next.m68k ldd.mvs.390 \
	cc.osf.alpha \
	cc.sco.i386 \
	cc.sgi.mips2 cc.sgi.mips3 cc.sgi.mips3-o32 cc.sgi.mips4 \
	cc.sgi.mips4-n32 ldd.sgi \
	cc.unix.mc68k

LICENSE : .DONTCARE

if ! CC.HOSTTYPE
	CC.HOSTTYPE := $(_hosttype_|HOSTTYPE)
end

$(BINDIR)/mkdir :INSTALL: mkdir.sh
	if	test ! -x $(<) -a -x /bin/mkdir
	then	mkdir -p 2>/dev/null || :
		if	test -d ./-p
		then	rmdir ./-p
			cp $(*) $(<)
			chmod +x $(<)
		fi
	fi

/*
 * ksh93 function search on PATH
 * ksh93 builtin command library -lcmd
 * ksh93 ld library path search on PATH
 */

$(BINDIR)/.paths :INSTALL: (CC.DIALECT)
	if	test ! -f $(<) -o -w $(<)
	then	nl="
"
		o=`cat $(<) 2>/dev/null` || :
		v=
		n=
		case $nl$o in
		*${nl}FPATH=*|*#FPATH=*|*[Nn][Oo]FPATH=*)
			;;
		*)	case $n in
			'')	;;
			*)	n="$n$nl" v="$v|" ;;
			esac
			n="${n}FPATH=../fun"
			v="${v}FPATH"
			;;
		esac
		case $nl$o in
		*${nl}BUILTIN_LIB=*|*#BUILTIN_LIB=*|*[Nn][Oo]BUILTIN_LIB=*)
			;;
		*)	case $n in
			'')	;;
			*)	n="$n$nl" v="$v|" ;;
			esac
			case '$(CC.DIALECT:N=*EXPORT=[AD]LL*)' in
			?*)	p= c= ;;
			*)	p='XX' ;;
			esac
			n="${n}${p}BUILTIN_LIB=cmd"
			v="${v}BUILTIN_LIB"
			;;
		esac
		set x x : $(-mam:??$(.GETCONF LIBPATH:/:/ /G:/,/ : /G:Q)?)
		p=
		while	:
		do	while	:
			do	case $# in
				0)	break ;;
				esac
				x=$1
				shift
				case $x in
				:)	break ;;
				esac
			done
			case $# in
			0|1)	break
				;;
			2)	p=$2
				;;
			*)	case "$(CC.HOSTTYPE)" in
				$3)	p=$2; break ;;
				esac
				;;
			esac
		done
		case $p in
		'')	if	test -x /lib/dld.sl
			then	p=SHLIB_PATH
			elif	test -x /usr/lib/dyld
			then	p=DYLD_LIBRARY_PATH
			else	case "$(CC.HOSTTYPE)" in
				ibm.*|mvs.*)
					p=LIBPATH
					;;
				sgi.mips3)	
					p=LD_LIBRARYN32_PATH
					;;
				sgi.mips4)	
					p=LD_LIBRARYN64_PATH
					;;
				*)	p=LD_LIBRARY_PATH
					;;
				esac
			fi
			;;
		esac
		case $nl$o in
		*${nl}${p}=*|*#${p}=*|*[Nn][Oo]${p}=*)
			;;
		*)	case $n in
			'')	;;
			*)	n="$n$nl" v="$v|" ;;
			esac
			n="${n}${p}=../lib"
			v="${v}${p}"
			;;
		esac
		case $n in
		?*)	case $o in
			?*)	o=`egrep -v "($v)=" $(<)`$nl ;;
			esac
			echo "# use { # no NO } prefix instead of XX to permanently disable #$nl$o$n" > $(<)
			;;
		esac
	fi

/*
 * probe initialization
 */

for T C+probe C+make+probe.lcl C+pp+probe.lcl
	if T == "*.lcl"
		$(T) : .DONTCARE
	end
	$(LIBDIR)/probe/$(T:C,+,/,G) :INSTALL: $(T)
end

$(LIBDIR)/probe/C/mam/probe :INSTALL: mprobe

mprobe :: mprobe.sh

$(LIBDIR)/probe/C/make :INSTALLDIR: probe probe.ini

probe.sh : C+probe make.probe
	cat $(*) > $(<)

probe :: probe.sh

probe.ini : (CC.HOSTTYPE) probe.win32
	t=$(CC.HOSTTYPE)
	ifs=$IFS
	IFS=.
	set x $t
	IFS=$ifs
	t=$2
	set x $(*)
	while	:
	do	shift
		case $# in
		0)	break ;;
		esac
		case $1 in
		*probe.$t)
			break
		esac
	done
	case $1 in
	?*)	cmp -s $1 $(<) || cp $1 $(<) ;;
	*)	: > $(<)
	esac

/*
 * proto initialization
 */

$(INCLUDEDIR) :INSTALLDIR: prototyped.h

prototyped.h : $(BINDIR)/proto
	proto -f /dev/null > h.$(tmp).h
	if	$(CMP) -s h.$(tmp).h $(<)
	then	$(RM) -f h.$(tmp).h
	else	$(MV) h.$(tmp).h $(<)
	fi

/*
 * check if -ldl is required
 * this allows makefiles to use -ldl on all systems
 *
 * NOTE: this works around the sgi botch:
 *	 (1) irix 5.* made -ldl optional but warned
 *	 (2) irix 6.* has no -ldl
 *	 (3) dynamic progs built on irix 5.* and using -ldl fail
 *           at runtime on irix 6.* because -ldl is not there
 */

dl :MAPLIB: dl.c

/*
 * requiring these is a botch
 */

iconv :MAPLIB: iconv.c

w :MAPLIB: w.c w2.c

/*
 * miscellaneous -l* checks
 */

intl :MAPLIB: intl.c

m :MAPLIB: m.c m2.c m3.c m4.c m5.c m6.c

nsl :MAPLIB: nsl.c

/*
 * what was sco smoking
 * almost all of gethost* are in -lnsl except gethostbyname which
 * is in -lsocket which isn't needed to resolve socket() but seems
 * to do the -lnsl job
 */

socket :MAPLIB: socket.c nsl.c

/*
 * more substance abuse
 * gdbm's ndbm "compatibility" doesn't supply <ndbm.h>, instead supplies
 * <gdbm/ndbm.h> which provides K&R prototypes *and* it requires -lgdbm
 * some <ndbm.h> implementations use -lndbm, others -ldbm, still others -lc
 * this is why unix is starting to look like windows
 * this map allows makefiles to use -ldbm on all systems
 *
 * and this just in: sometimes its <gdbm-ndbm.h> and possibly -lgdbm_compat
 *
 * at least the -l* buck stops here
 */

dbm db - gdbm_compat - gdbm - ndbm - dbm :MAPLIB: db.c gdbm.c gdbm1.c gdbm2.c

=== src/cmd/ksh93/Makefile ===
/*
 * ksh makefile
 */

SH := $(PWD:B:/[0-9]*$//:N=ksh*:-ksh)		/* name of the shell program */
VERSION = 1.1
LICENSE = since=1982,author=dgk
CATALOG = libshell
ERROR_CONTEXT_T == Error_context_t /* workaround until switch from errorpush()/errorpop() => errorctx() */
RELEASE := $(SH:/.*sh//)
SHCOMP := shcomp$(RELEASE)

/*
 * set these variables to 1 to enable, 0 to disable, null to probe
 * override SHOPT_foo=1 can be placed one per line in the build dir Makeargs
 */

SHOPT_2DMATCH == 1		/* two dimensional .sh.match for ${var//pat/str} */
SHOPT_ACCT ==  			/* accounting */
SHOPT_ACCTFILE ==  		/* per user accounting info */
SHOPT_AUDIT ==
SHOPT_AUDITFILE == "/etc/ksh_audit"  		/* auditing file */
SHOPT_BASH ==			/* bash compatibility code */
SHOPT_BGX == 1			/* one SIGCHLD trap per completed job */
SHOPT_BRACEPAT == 1		/* C-shell {...,...} expansions (, required) */
SHOPT_CMDLIB_HDR ==		/* -lcmd builtin list: <cmdlist.h> */
SHOPT_CMDLIB_DIR ==		/* SHOPT_CMDLIB_HDR prefix SH_CMDLIB_DIR + <cmdlist.h> */
SHOPT_COSHELL == 1		/* build with connection to coshell */
SHOPT_CRNL ==			/* accept <cr><nl> for <nl> */
SHOPT_DYNAMIC == 1		/* dynamic loading for builtins */
SHOPT_ECHOPRINT ==		/* make echo equivalent to print */
SHOPT_EDPREDICT == 1		/* predictive editing  */
SHOPT_ESH == 1			/* emacs/gmacs edit mode */
SHOPT_FILESCAN == 1		/* fast file scan */
SHOPT_FIXEDARRAY == 1		/* fixed dimension indexed array */
SHOPT_FS_3D == 			/* 3d file system */
SHOPT_HISTEXPAND == 1		/* csh-style history file expansions */
SHOPT_KIA == 1			/* shell information database generation */
SHOPT_MULTIBYTE == 1		/* multibyte character handling */
SHOPT_NAMESPACE == 1		/* allow namespaces */
SHOPT_OLDTERMIO ==		/* support both TCGETA and TCGETS */
SHOPT_OPTIMIZE == 1		/* optimize loop invariants */
SHOPT_PFSH == 1			/* solaris exec_attr(4) profile execution */
SHOPT_P_SUID ==			/* real uid's that require -p for set[ug]id */
SHOPT_RAWONLY == 1		/* make viraw the only vi mode */
SHOPT_REGRESS ==		/* enable __regress__ builtin and instrumented intercepts for testing */
SHOPT_REMOTE ==			/* enable --rc if running as a remote shell */
SHOPT_SEVENBIT ==		/* strip the eigth bit from characters */
SHOPT_SPAWN ==			/* use spawnveg for fork/exec */
SHOPT_STATS ==	1		/* add .sh.stats variable */
SHOPT_SUID_EXEC == 1		/* allow (safe) suid/sgid shell scripts */
SHOPT_SYSRC ==			/* attempt . /etc/ksh.kshrc if interactive */
SHOPT_TIMEOUT ==		/* number of seconds for shell timeout */
SHOPT_TYPEDEF == 1		/* enable typeset type definitions */
SHOPT_VSH == 1			/* vi edit mode */

if CC.HOSTTYPE == "linux.alpha"
	/* workaround for "BUG IN DYNAMIC LINKER ld.so" */
	:PACKAGE: - m:static:noinclude /*noCC.EXPORT.DYNAMIC*/
end

if CC.HOSTTYPE == "*.s390-64"
	CC.DLL = $(CC.DLLBIG)
end

if SHOPT_DYNAMIC && ( "$(CC.DIALECT:N=EXPORT=DLL)" || "$(PACKAGE_OPTIONS:N=optimize-space)" )
	CCFLAGS += $$(CC.DLL) $$(CC.SUFFIX.DEBUG:+$$(CC.DEBUG))
	LIBS_req = -lshell$(RELEASE)
else
	if VARIANT
		SHOPT_DYNAMIC = 1
	else
		libtype = :static
	end
	if SHOPT_DYNAMIC
		CCLDFLAGS += $$(CC.EXPORT.DYNAMIC)
	end
	LIBS_req = +lshell$(RELEASE)
end

:PACKAGE: ast$(libtype):20100309 coshell:order --clobber=!($(SH))

.SOURCE : edit sh bltins data tests fun
.SOURCE.h : include 

/* documentation files */
DOCFILES = sh.memo builtins.mm README RELEASE TYPES PROMO.mm COMPATIBILITY \
		DESIGN OBSOLETE RELEASE93 RELEASE88

KSHELL == 1			/* this is ksh */

SH_CMDLIB_DIR ==		/* SHOPT_CMDLIB_DIR dir prefix */
SH_DICT ==			/* message catalog */
DEBUG ==			/* debugging purposes only */

if  CC.HOSTTYPE == "win32*"
	SHOPT_CRNL == 1		/* <cr><nl> is eqivalent to <nl> */
end

if SHOPT_BASH
	BASH_HOSTTYPE == "$(CC.HOSTTYPE:S:/\.//)"
	BASH_MACHTYPE == "$(BASH_HOSTTYPE)-unknown-$(CC.HOSTTYPE:B)"
end

/* use the following libraries only if they exist */
LIBS_opt := +ljobs +li

if  CC.HOSTTYPE == "sol([89]|[1-9][0-9]).*"
	LDFLAGS  += $(CC.LD.LAZY) $(CC.LD.NORECORD)
end

if "$(-mam:N=static*)"
	LIBS_opt += -lsocket -lnsl
elif CC.HOSTTYPE == "sol?([789]|[1-9][0-9]).*"
	LIBS_opt += +lsocket -lnsl
elif CC.HOSTTYPE != "sgi.mips*"
	LIBS_opt += +lsocket +lnsl
end
if CC.HOSTTYPE == "linux.sparc*"
	/* the linux.sparc linker still has some problems */
	LIBS_opt += -ldll
end
LIBS_opt += -lsecdb
if CC.HOSTTYPE == "sol.*"
	LIBS_opt += +lw
end
$(LIBS_opt)	: .DONTCARE

LDLIBRARIES = $(LIBS_opt)

FILES_opt =		/* optional file list enabled by vars above */
if SHOPT_ESH
	FILES_opt += emacs.c
end
if SHOPT_VSH
	FILES_opt += vi.c
end
if SHOPT_BASH
	FILES_opt += bash.c bash_pre_rc.c
	SHOPT_HISTEXPAND == 1
end
if SHOPT_HISTEXPAND
	FILES_opt += hexpand.c
end
if SHOPT_DYNAMIC
	FILES_opt += -ldll
end
if SHOPT_X
	LDFLAGS += -u _XtAppInitialize -L/usr/add-on/X11/lib
end

:ALL: $(SH) $(SHCOMP) $(SHOPT_SUID_EXEC:+suid_exec) $(SHOPT_BASH:+bash$(RELEASE))

$(SH) :: sh.1 pmain.c $(LIBS_req)

DATAFILES = limits.c msg.c strdata.c testops.c keywords.c options.c \
                 signals.c aliases.c builtins.c variables.c lexstates.c

shell$(RELEASE) $(VERSION) id=shell :LIBRARY: shell.3 nval.3 alarm.c cd_pwd.c cflow.c deparse.c \
	enum.c getopts.c hist.c misc.c print.c read.c sleep.c trap.c test.c \
	typeset.c ulimit.c umask.c whence.c main.c nvdisc.c nvtype.c \
	arith.c args.c array.c completion.c defs.c edit.c expand.c regress.c \
	fault.c fcin.c history.c init.c io.c jobs.c lex.c macro.c name.c \
	nvtree.c parse.c path.c string.c streval.c subshell.c tdump.c timers.c \
	trestore.c waitevent.c xec.c env.c $(DATAFILES) $(FILES_opt) \
	$(SHOPT_COSHELL:+-lcoshell) -lcmd -last -lm

"sol*.i386*"	:NOOPTIMIZE: main.c
"win32*"	:NOOPTIMIZE: strdata.c trestore.c

if CC.HOSTTYPE == "win32*"
:DLL: $(CC.DEBUG)
else
:DLL: $(CC.OPTIMIZE)
end

:READONLY: $(DATAFILES)

$(INCLUDEDIR) :INSTALLPROTO: nval.h shell.h history.h

LIBCMD = $(.LIB.NAME. cmd:T=F)

if SHOPT_SUID_EXEC && ! "$(RELEASE)"
suid_exec ::	CC.DLL= suid_exec.c +last
end

$(SHCOMP) ::	CC.DLL= SH_DICT='"libshell"' shcomp.c $(LIBS_req)

$(FUNDIR) :INSTALLDIR: mode=+x dirs popd pushd

shcomp.o : _BLD_DLL= $(CC.HOSTTYPE:N=cygwin.*:??_BLD_shell=?)

if SHOPT_BASH

bash$(RELEASE) :LINK: $(SH)

bash_pre_rc.c : bash_pre_rc.sh
	echo "const char bash_pre_rc[] = " > $(<)
	sed -e 's/\\/\\\\/g' -e 's/"/\\"/g' -e 's/'"'"'/\\'"'"'/g' -e 's/^[[:space:]]*\(.*\)$/\"\1\\n\"/' $(*) >> $(<)
	echo ";" >> $(<)

end

:: math.tab syscall.s mamexec mamstate.c $(DOCFILES) \
	bash.c bash_pre_rc.sh hexpand.c mkservice.c \
	shopen.mk shopen.c

:: shtests \
	alias.sh append.sh arith.sh arrays.sh arrays2.sh \
	attributes.sh basic.sh bracket.sh builtins.sh case.sh \
	comvar.sh comvario.sh coprocess.sh cubetype.sh enum.sh exit.sh \
	expand.sh functions.sh glob.sh grep.sh heredoc.sh io.sh \
	leaks.sh locale.sh math.sh nameref.sh options.sh path.sh \
	pointtype.sh pty.sh quoting.sh quoting2.sh readcsv.sh recttype.sh \
	restricted.sh return.sh select.sh shtests sigchld.sh \
	signal.sh statics.sh subshell.sh substring.sh tilde.sh \
	timetype.sh treemove.sh types.sh variables.sh \
	vartree1.sh vartree2.sh

:: ksh-regress.rt ksh-regress.tst

if "$(PWD:B:N=cc-*)"

test : .NULL

else

test : test.ksh

test.ksh : $(BINDIR)/$(SH) $(SH) shtests
	$(SILENT) $(CMP) $(CMPFLAGS) $(*:O=1) $(*:O=2) 2>/dev/null ||
	echo "make install to run the tests on the latest $(SH)" >&2
	cd $(*:O=3:P=L!:D)
	SHELL=$(*:O=1:P=A) $(*:O=1:P=A) $(*:O=3:B) $(SHTESTSFLAGS)

test.% : %.sh COSHELL_OPTIONS=separate $(BINDIR)/$(SH) $(SH) shtests
	$(SILENT) $(CMP) $(CMPFLAGS) $(*:O=2) $(*:O=3) 2>/dev/null ||
	echo "make install to run the tests on the latest $(SH)" >&2
	cd $(*:O=4:P=L!:D)
	SHELL=$(*:O=2:P=A) $(*:O=2:P=A) $(*:O=4:B) $(SHTESTSFLAGS) $(*:O=1:P=A)

if RELEASE

.INSTALL : .CLEAR $(*.INSTALL:N=*$(RELEASE)*([!/]))

end

end

=== src/lib/libast/Makefile ===
/*
 * ast library
 */

:PACKAGE: ast

LICENSE = since=1985,author=gsf+dgk+kpv

ID = ast

HOSTTYPE == "$(CC.HOSTTYPE)"

CCFLAGS = $(CC.SUFFIX.DEBUG:+$(CC.DEBUG)) $(CC.OPTIMIZE) $(CC.DLL)

IFFEFLAGS = -v -X ast -X std

.SOURCE : aso cdt comp dir disc hash man misc obsolete path port preroot \
		regex sfio stdio string tm uwin vec vmalloc

.SOURCE.h : include comp std cdt vmalloc

CP = $(STDCP|"cp")

PARANOID ==
CONF_LIBPREFIX == "$(CC.PREFIX.DYNAMIC|CC.PREFIX.SHARED)"
CONF_LIBSUFFIX == "$(CC.SUFFIX.DYNAMIC|CC.SUFFIX.SHARED)"
DEBUG ==
__OBSOLETE__ == $("6 months ago":@F=%(%Y0101)T)

HEADERSRC = ast.h ast_dir.h ast_getopt.h ast_std.h \
	ast_namval.h ast_windows.h \
	ccode.h cdt.h cdtlib.h cmdarg.h debug.h dt.h error.h find.h ftw.h \
	ftwalk.h fts.h fs3d.h getopt.h glob.h hash.h hashkey.h hashpart.h \
	ip6.h lc.h ls.h magic.h mc.h mime.h mnt.h modecanon.h modex.h \
	namval.h option.h proc.h re_comp.h recfmt.h regex.h regexp.h \
	sfio.h sfio_s.h sfio_t.h sfdisc.h shcmd.h \
	stack.h stak.h stk.h swap.h tar.h times.h tm.h tok.h \
	usage.h vdb.h vecargs.h vmalloc.h wait.h wordexp.h \
	bytesex.h endian.h fnmatch.h magicid.h fnv.h aso.h \
	$(HEADERSTD)

HEADERGEN = align.h preroot.h sig.h tmx.h tv.h \
	$(ID)_api.h $(ID)_botch.h $(ID)_ccode.h $(ID)_fcntl.h $(ID)_float.h \
	$(ID)_fs.h $(ID)_lib.h $(ID)_map.h $(ID)_mmap.h $(ID)_mode.h $(ID)_ndbm.h \
	$(ID)_param.h $(ID)_sys.h $(ID)_time.h $(ID)_time.h $(ID)_tty.h \
	$(ID)_vfork.h $(ID)_wait.h $(ID)_limits.h $(ID)_standards.h $(ID)_sizeof.h \
	$(HEADERSTD:/^/$(ID)_/)

HEADEREXP = $(ID)_common.h

HEADEROPT = fmtmsg.h libgen.h syslog.h

HEADERSTD = dirent.h iconv.h nl_types.h stdio.h wchar.h wctype.h

$(ID) 5.4 :LIBRARY: README RELEASE \
	LIBAST.3 aso.3 ast.3 astsa.3 cdt.3 chr.3 compat.3 error.3 \
	find.3 fmt.3 fmtls.3 fs3d.3 ftwalk.3 getcwd.3 hash.3 iblocks.3 \
	int.3 ip6.3 magic.3 mem.3 mime.3 modecanon.3 optget.3 path.3 \
	preroot.3 proc.3 re.3 regex.3 setenviron.3 sfdisc.3 sfio.3 \
	sig.3 spawnveg.3 stak.3 stk.3 strcopy.3 strdup.3 strelapsed.3 \
	strerror.3 stresc.3 streval.3 strgid.3 strmatch.3 stropt.3 \
	strperm.3 strsignal.3 strsort.3 strtape.3 strton.3 struid.3 \
	swap.3 tab.3 tm.3 tmx.3 tok.3 touch.3 tv.3 vecargs.3 vmalloc.3 \
	$(HEADERSRC) \
	state.c transition.c \
	dirlib.h opendir.c readdir.c rewinddir.c seekdir.c telldir.c \
	getcwd.c fastfind.c \
	hashlib.h hashalloc.c hashdump.c hashfree.c hashlast.c \
	hashlook.c hashscan.c hashsize.c hashview.c hashwalk.c \
	memhash.c memsum.c strhash.c strkey.c strsum.c \
	stracmp.c strnacmp.c \
	ccmap.c ccmapid.c ccnative.c \
	chresc.c chrtoi.c streval.c strexpr.c strmatch.c strcopy.c \
	modelib.h modei.c modex.c strmode.c \
	strlcat.c strlcpy.c strlook.c strncopy.c strsearch.c strpsearch.c \
	stresc.c stropt.c strtape.c strpcmp.c strnpcmp.c strvcmp.c strnvcmp.c \
	tok.c tokline.c tokscan.c \
	pathaccess.c pathcat.c pathcanon.c pathcheck.c pathpath.c \
	pathexists.c pathfind.c pathkey.c pathprobe.c pathrepl.c \
	pathnative.c pathposix.c pathtemp.c pathtmp.c pathstat.c \
	pathgetlink.c pathsetlink.c pathbin.c pathshell.c pathcd.c \
	pathprog.c \
	fs3d.c ftwalk.c ftwflags.c fts.c \
	astintercept.c conformance.c getenv.c setenviron.c \
	optget.c optjoin.c optesc.c optctx.c strsort.c struniq.c \
	magic.c mime.c mimetype.c signal.c sigflag.c systrace.c \
	error.c errorf.c errormsg.c errorx.c \
	localeconv.c setlocale.c translate.c \
	catopen.c iconv.c lc.c lctab.c mc.c \
	base64.c recfmt.c recstr.c reclen.c fmtrec.c \
	fmtbase.c fmtbuf.c fmtclock.c fmtdev.c fmtelapsed.c fmterror.c \
	fmtesc.c fmtfmt.c fmtfs.c fmtident.c fmtint.c fmtip4.c fmtip6.c fmtls.c \
	fmtmatch.c fmtmode.c fmtnum.c fmtperm.c fmtre.c fmttime.c fmtuid.c \
	fmtgid.c fmtsignal.c fmtscale.c fmttmx.c fmttv.c fmtversion.c \
	strelapsed.c strperm.c struid.c strgid.c \
	strtoip4.c strtoip6.c stack.c stk.c \
	swapget.c swapmem.c swapop.c swapput.c \
	sigdata.c sigcrit.c sigunblock.c \
	proclib.h procopen.c procclose.c procrun.c procfree.c \
	tmdate.c tmequiv.c tmfix.c tmfmt.c tmform.c tmgoff.c tminit.c \
	tmleap.c tmlex.c tmlocale.c tmmake.c tmpoff.c tmscan.c \
	tmsleep.c tmtime.c tmtype.c tmweek.c tmword.c tmzone.c \
	tmxdate.c tmxduration.c tmxfmt.c tmxgettime.c tmxleap.c tmxmake.c \
	tmxscan.c tmxsettime.c tmxsleep.c tmxtime.c tmxtouch.c \
	tvcmp.c tvgettime.c tvsettime.c tvsleep.c tvtouch.c \
	cmdarg.c vecargs.c vecfile.c vecfree.c vecload.c vecstring.c \
	univlib.h univdata.c touch.c mnt.c debug.c \
	memccpy.c memchr.c memcmp.c memcpy.c memdup.c memmove.c memset.c \
	mkdir.c mkfifo.c mknod.c rmdir.c remove.c rename.c link.c unlink.c \
	strdup.c strchr.c strrchr.c strstr.c \
	strtod.c strtold.c \
	strtol.c strtoll.c strtoul.c strtoull.c strton.c strtonll.c \
	strntod.c strntold.c strnton.c strntonll.c \
	strntol.c strntoll.c strntoul.c strntoull.c \
	strcasecmp.c strncasecmp.c strerror.c \
	mktemp.c tmpnam.c fsync.c \
	execlp.c execve.c execvp.c execvpe.c spawnveg.c \
	vfork.c killpg.c \
	hsearch.c tsearch.c \
	getlogin.c putenv.c setenv.c unsetenv.c \
	lstat.c statvfs.c \
	eaccess.c gross.c gross_sgi.h omitted.c \
	fakelink.h readlink.c symlink.c \
	getpgrp.c setpgid.c setsid.c waitpid.c \
	creat64.c fcntl.c open.c \
	atexit.c getdents.c getwd.c dup2.c errno.c \
	getpreroot.c ispreroot.c realopen.c setpreroot.c \
	getgroups.c mount.c system.c iblocks.c \
	modedata.c tmdata.c \
	memfatal.c sfkeyprintf.c \
	sfdcdio.c sfdcdos.c sfdcfilter.c sfdcseekable.c \
	sfdcslow.c sfdcsubstr.c sfdctee.c sfdcunion.c \
	sfdcmore.c sfdcprefix.c \
	wc.c wc2utf8.c \
	/* standards */ \
	basename.c closelog.c dirname.c fmtmsglib.c fnmatch.c ftw.c \
	getdate.c getsubopt.c glob.c nftw.c openlog.c re_comp.c \
	resolvepath.c realpath.c regcmp.c regexp.c setlogmask.c strftime.c \
	strptime.c swab.c syslog.c sysloglib.h tempnam.c \
	wordexp.c mktime.c \
	/* regex */ \
	reglib.h regalloc.c regclass.c regcoll.c regcomp.c regcache.c \
	regdecomp.c regerror.c regexec.c regfatal.c reginit.c regnexec.c \
	regsubcomp.c regsubexec.c regsub.c regrecord.c regrexec.c regstat.c \
	/* cdt */ \
	dthdr.h dtclose.c dtdisc.c dthash.c dtlist.c dtmethod.c \
	dtopen.c dtstrhash.c dttree.c dtview.c dtwalk.c \
	dtnew.c dtcomp.c \
	/* sfio */ \
	sfhdr.h sfdchdr.h \
	sfclose.c sfclrlock.c sfdisc.c sfdlen.c sfexcept.c \
	sfgetl.c sfgetu.c sfcvt.c sfecvt.c sffcvt.c \
	sfextern.c sffilbuf.c sfflsbuf.c sfprints.c sfgetd.c \
	sfgetr.c sfllen.c sfmode.c sfmove.c sfnew.c \
	sfpkrd.c sfnotify.c sfnputc.c sfopen.c sfpeek.c sfpoll.c \
	sfpool.c sfpopen.c sfprintf.c sfputd.c sfputl.c sfputr.c \
	sfputu.c sfrd.c sfread.c sfreserve.c sfscanf.c sfseek.c sfset.c \
	sfsetbuf.c sfsetfd.c sfsize.c sfsk.c sfstack.c sfstrtod.c sfsync.c \
	sfswap.c sftable.c sftell.c sftmp.c sfungetc.c sfvprintf.c \
	sfvscanf.c sfwr.c sfwrite.c sfpurge.c sfraise.c sfwalk.c \
	sfgetm.c sfmutex.c sfputm.c sfresize.c \
	_sfclrerr.c _sfeof.c _sferror.c _sffileno.c \
	_sfopen.c _sfstacked.c _sfvalue.c \
	_sfgetc.c _sfgetl.c _sfgetl2.c _sfgetu.c _sfgetu2.c \
	_sfdlen.c _sfllen.c _sfslen.c _sfulen.c \
	_sfputc.c _sfputd.c _sfputl.c _sfputm.c _sfputu.c \
	/* stdio */ \
	clearerr.c fclose.c fdopen.c feof.c ferror.c fflush.c \
	fgetc.c fgetpos.c fgets.c fileno.c fopen.c fprintf.c \
	fpurge.c fputc.c fputs.c fread.c freopen.c fscanf.c \
	fseek.c fseeko.c fsetpos.c ftell.c ftello.c fwrite.c \
	flockfile.c ftrylockfile.c funlockfile.c \
	getc.c getchar.c getw.c pclose.c popen.c printf.c \
	putc.c putchar.c puts.c putw.c rewind.c scanf.c \
	setbuf.c setbuffer.c setlinebuf.c setvbuf.c \
	snprintf.c sprintf.c sscanf.c \
	asprintf.c vasprintf.c \
	stdio/tmpfile.c ungetc.c vfprintf.c vfscanf.c vprintf.c \
	vscanf.c vsnprintf.c vsprintf.c vsscanf.c \
	_doprnt.c _doscan.c _filbuf.c _flsbuf.c _stdfun.c \
	_stdopen.c _stdprintf.c _stdscanf.c _stdsprnt.c \
	_stdvbuf.c _stdvsnprnt.c _stdvsprnt.c _stdvsscn.c \
	/* wchar stdio */ \
	fgetwc.c fwprintf.c putwchar.c vfwscanf.c wprintf.c \
	fgetws.c fwscanf.c swprintf.c vswprintf.c wscanf.c \
	fputwc.c getwc.c swscanf.c vswscanf.c \
	fputws.c getwchar.c ungetwc.c vwprintf.c \
	fwide.c putwc.c vfwprintf.c vwscanf.c \
	/* stdio extensions */ \
	stdio_c99.c fcloseall.c fmemopen.c getdelim.c getline.c \
	/* math */ \
	frexp.c frexpl.c \
	/* ast */ \
	astcopy.c astconf.c astdynamic.c astlicense.c astquery.c astwinsize.c \
	conftab.c \
	$(CC.LD.STATIC) aststatic.c getopt.c getoptl.c $(CC.LD.DYNAMIC) \
	/* aso */ \
	aso.c asolock.c asometh.c asorelax.c aso-sem.c aso-fcntl.c \
	/* vmalloc */ \
	vmalloc.h vmhdr.h vmbest.c vmclear.c vmclose.c vmdcheap.c vmdebug.c \
	vmdisc.c vmexit.c vmlast.c vmopen.c vmpool.c vmprivate.c vmprofile.c \
	vmregion.c vmsegment.c vmset.c vmstat.c vmstrdup.c vmtrace.c vmwalk.c \
	vmmopen.c malloc.c vmgetmem.c \
	/* uwin */ \
	mathimpl.h rlib.h \
	a64l.c acosh.c asinh.c atanh.c cbrt.c crypt.c erf.c \
	err.c exp.c exp__E.c expm1.c gamma.c getpass.c lgamma.c log.c log1p.c \
	log__L.c rand48.c random.c rcmd.c rint.c support.c \
	/* obsolete */ \
	sfstrtmp.c spawn.c \
	-liconv -lw /* these should be pulled in by -lc */

/*
 * man is stdio.h problematic
 * the std/stdio.h => ast_stdio.h runaround should
 * get to a steady state
 *
 * also, -D_BLD_ast must be explicit for the uwin bootstrap
 */

.MAKEINIT : .AST.INIT
.AST.INIT : .MAKE
	CCFLAGS += -D_BLD_ast

parameter	(_BLD_ast)
virtual		ast/stdio.h

		:NOPROTECT: sfprintf.c sfvprintf.c sfscanf.c sfvscanf.c

		:NOOPTIMIZE: spawnveg.c
"ibm.risc"	:NOOPTIMIZE: regcomp.c
"linux.i386-64*":NOOPTIMIZE: sfset.c
"sol?.*"	:NOOPTIMIZE: sfrd.c sfvprintf.c tmxfmt.c
"win32*"	:NOOPTIMIZE: fastfind.c mc.c

/*
 * NOTE: sun4 runtime link botches ro data so advertised sig_info is rw
 */

:READONLY: conftab.c lctab.c modedata.c /*sftable.c*/ \
	/*sigdata.c*/ tmdata.c univdata.c

:: atmain.C \
	stdgets.c stdprintf.c stdscanf.c stdvbuf.c stdsprnt.c \
	stdvsprnt.c stdvsnprnt.c stdvsscn.c stdopen.c \
	astsa

if "$(PWD:B)" != "cc-*"

$(INCLUDEDIR) :INSTALLPROTO: $(HEADEREXP) $(HEADERSRC) $(HEADERGEN)

:INSTALLDIR: conf

conf :: conf.sh

conflim.h conftab.h conftab.c :JOINT: conf conf.tab
	$(*:O=1:P=A) $(IFFEFLAGS:V:N=-v) $(*:O>1) $(CC) $(CCFLAGS:VP:N!=-D_BLD_*|$\(*\)) /* 2007-07-01: $(CCFLAGS:VPX:N!=-D_BLD_*) */

$(HEADERGEN) :COPY: FEATURE/$$(<:B:/$(ID)_//)

ast_namval.h :COPY: namval.h

lcgen : lcgen.c
	$(CC.NATIVE|CC) -o $(<) $(*)

lc.h lctab.c :JOINT: lcgen lc.tab
	$(*:O=1:C,^[^/],./&,) $(tmp).1 $(tmp).2 < $(*:O=2) # :P=E: in 2006
	$(PROTO) -p $(PROTOFLAGS) $(tmp).1 $(PROTOINSTALL) > $(tmp).3
	$(RM) -f $(tmp).1
	if	$(CMP) -s $(tmp).3 $(<:O=1)
	then	$(RM) $(tmp).3
	else	$(MV) $(tmp).3 $(<:O=1)
	fi
	if	$(CMP) -s $(tmp).2 $(<:O=2)
	then	$(RM) $(tmp).2
	else	$(MV) $(tmp).2 $(<:O=2)
	fi

$(LIBDIR)/file/magic :INSTALL: magic.tab

:INSTALL: $(HEADEROPT:D=$(INCLUDEDIR):B:S)

$(HEADEROPT:D=$(INCLUDEDIR):B:S) : $$(<:B:S) ast_lib.h
	case $(CC.HOSTTYPE) in
	win32.*)$(PROTO) -p $(PROTOFLAGS) $(*:O=1) $(PROTOINSTALL) > 1.$(tmp).x
		if	$(CMP) -s $(<) 1.$(tmp).x
		then	$(RM) -f 1.$(tmp).x
		else	$(MV) 1.$(tmp).x $(<)
		fi
		;;
	*)	$(SILENT) $(GREP) -l 'define[ 	][ 	]*_[hl][di][rb]_$(<:B)' $(*:O>1) > /dev/null || {
		$(PROTO) -p $(PROTOFLAGS) $(*:O=1) $(PROTOINSTALL) > 1.$(tmp).x
		if	$(CMP) -s $(<) 1.$(tmp).x
		then	$(RM) -f 1.$(tmp).x
		else	$(MV) 1.$(tmp).x $(<)
		fi
		}
		;;
	esac

/* a few headers are problematic */

$(INCLUDEDIR)/prototyped.h :INSTALL: $(INCLUDEDIR)
	echo "#include <../prototyped.h>" > 1.$(tmp).x
	if	$(CMP) -s $(<) 1.$(tmp).x
	then	$(RM) -f 1.$(tmp).x
	else	$(MV) 1.$(tmp).x $(<)
	fi

/*
 * FEATURE/common for iffe probes, <ast_common.h> for ast source
 * *but* <ast_common.h> may get pulled in by intercepted headers
 * so both must be built very early
 */

$(ID)_common.h : .SCAN.IGNORE FEATURE/common
	$(SED) '/define _def_map_ast/d' < $(*) > 1.$(tmp).x
	if	$(CMP) -s $(<) 1.$(tmp).x
	then	$(RM) -f 1.$(tmp).x
	else	$(MV) 1.$(tmp).x $(<)
	fi

FEATURE/common : .SCAN.IGNORE

/*
 * more stdio.h complications ...
 * prepare for compilation by generating these headers first;
 * this helps mam by catching headers that might be indirectly

=== src/lib/libcmd/Makefile ===
/*
 * command library -- commands small enough to be builtins
 */

:PACKAGE: ast

LICENSE = since=1992,author=gsf+dgk

CCFLAGS = $(CC.SUFFIX.DEBUG:+$(CC.DEBUG)) $(CC.OPTIMIZE) $(CC.DLL)

/* 2009-04-15 ld.so experiment -- may become a default for all plugins */
CC.DLL.ORIGIN = $(CC.LD.ORIGIN:C,/.*,,)
LDFLAGS = $(CC.DLL.ORIGIN)

CP = $(STDCP|"cp")
CHMOD = $(STDCHMOD|"chmod")

HOSTTYPE == "$(CC.HOSTTYPE)"

cmd 1.2 :LIBRARY: RELEASE cmdinit.c \
	cmd.h rev.h wc.h \
	basename.c cat.c chgrp.c chmod.c chown.c cksum.c cmp.c \
	comm.c cp.c cut.c dirname.c date.c expr.c fds.c fmt.c fold.c \
	getconf.c head.c id.c join.c ln.c logname.c md5sum.c mkdir.c \
	mkfifo.c mktemp.c mv.c paste.c pathchk.c pids.c rev.c rm.c \
	rmdir.c stty.c sum.c sync.c tail.c tee.c tty.c uname.c uniq.c \
	vmstate.c wc.c revlib.c wclib.c sumlib.o \
	fts_fix.c lib.c \
	-lfsg -lmd

sumlib.o : +lsum
	$(AR) x $(*:O=1) $(<)

$(INCLUDEDIR) :INSTALLPROTO: cmd.h cmdext.h cmdlist.h

"win32*" :NOOPTIMIZE: id.c

src = $(*$(*$(*cmd)):N=*.c:T=F)

cmdext.h : (src) $$(-mam:+$$(src))
	{
	cat <<!
	$("#")pragma prototyped
	$("/")*
	$(" ")* -lcmd extern function prototypes
	$(" ")*/
	
	$("#")include <shcmd.h>

	!
	$(SED) \
		-e '/^b_[a-z_][a-z_0-9]*(/!d' \
		-e 's/^b_//' \
		-e 's/(.*//' \
		-e 's/.*/extern int	b_&(int, char**, Shbltin_t*);/' \
		$($(~:O=1)) |
	$(SORT) -u
	} > 1.$(tmp).h
	if	$(CMP) $(CMPFLAGS) 1.$(tmp).h $(<)
	then	$(RM) $(RMFLAGS) 1.$(tmp).h
	else	$(MV) 1.$(tmp).h $(<)
	fi

cmdlist.h : (src)
	{
	cat <<!
	$("#")pragma prototyped
	$("/")*
	$(" ")* -lcmd function list -- define your own CMDLIST()
	$(" ")*/
	
	!
	$(SED) \
		-e '/^b_[a-z_][a-z_0-9]*(/!d' \
		-e 's/^b_//' \
		-e 's/(.*//' \
		-e 's/.*/CMDLIST(&)/' \
		$($(~):T=F) |
	$(SORT) -u
	} > 1.$(tmp).h
	if	$(CMP) $(CMPFLAGS) 1.$(tmp).h $(<)
	then	$(RM) $(RMFLAGS) 1.$(tmp).h
	else	$(MV) 1.$(tmp).h $(<)
	fi

if CC.HOSTTYPE == "sun4"
	pathsetlink == symlink	/* ld.so workaround */
end

ignore dlldefs.h /* prevents bootstrap double build */

=== debian/rules ===
#!/usr/bin/make -f
PACKAGE = ksh
SRC_VERSION := 93u+
DL_VERSION = 2012-02-29
SRC_DIR = $(PACKAGE)-$(SRC_VERSION)
TARBALL = $(SRC_DIR).tar.gz

CFLAGS = -g
LDFLAGS =
SHELL = /bin/sh
ARCH = $(shell bin/package)
INSTALL = install
INSTALL_FILE    = $(INSTALL) -p    -o root -g root  -m  644
INSTALL_PROGRAM = $(INSTALL) -p    -o root -g root  -m  755

package=ksh

ifneq (,$(findstring noopt,$(DEB_BUILD_OPTIONS)))
CFLAGS += -O0
else
CFLAGS += -O2
endif

ifeq (,$(findstring nostrip,$(DEB_BUILD_OPTIONS)))
INSTALL_PROGRAM += -s
endif

export CCFLAGS = $(CFLAGS)

build: build-stamp
build-stamp:
	bin/package make strip=0
	touch build-stamp

clean:
	dh_testdir
	dh_clean
	-test -f bin/ignore.old && mv bin/ignore.old bin/ignore
	-test -f bin/silent.old && mv bin/silent.old bin/silent
	-test -f bin/package.old && mv bin/package.old bin/package
	-test -f bin/mamprobe.old && mv bin/mamprobe.old bin/mamprobe
	-rm -rf arch/$(ARCH)

install: build
	dh_testdir
	dh_testroot
	dh_installdirs
	$(INSTALL_PROGRAM) arch/$(ARCH)/bin/ksh debian/ksh/bin/ksh93
	$(INSTALL_PROGRAM) arch/$(ARCH)/bin/shcomp debian/ksh/usr/bin/shcomp
	$(INSTALL_FILE) arch/$(ARCH)/man/man1/sh.1 debian/ksh/usr/share/man/man1/ksh93.1
	$(INSTALL_FILE) arch/$(ARCH)/fun/* debian/ksh/usr/share/ksh/functions
	$(INSTALL_FILE) debian/shcomp.1 debian/ksh/usr/share/man/man1/shcomp.1
	$(INSTALL_FILE) debian/fr-shcomp.1 debian/ksh/usr/share/man/fr/man1/shcomp.1
	dh_installdocs
	dh_installmenu
	dh_installchangelogs

# Build architecture-independent files here.
binary-indep: build install
# We have nothing to do by default.

# Build architecture-dependent files here.
binary-arch: build install
	dh_compress
	dh_fixperms
	dh_installdeb
	dh_shlibdeps
	dh_gencontrol
	dh_md5sums
	dh_builddeb

binary: binary-indep binary-arch

get-orig-source:
	rm -rf $(SRC_DIR) $(TARBALL)
	mkdir $(SRC_DIR)
	wget --http-user 'I accept www.opensource.org/licenses/cpl' \
	  --http-password . -O - \
	  http://www.research.att.com/~gsf/download/tgz/INIT.$(DL_VERSION).tgz | \
	  tar xzf - -C $(SRC_DIR)
	wget --http-user 'I accept www.opensource.org/licenses/cpl' \
	  --http-password . -O - \
	  http://www.research.att.com/~gsf/download/tgz/ast-ksh.$(DL_VERSION).tgz | \
	  tar xzf - -C $(SRC_DIR)
	tar cf - $(SRC_DIR) | tardy -group 0 -user 0 - - | gzip -c9 > $(TARBALL)

.PHONY: build clean binary-indep binary-arch binary install get-orig-source

## ksh 93u+20120801

=== src/lib/libdll/Makefile ===
:PACKAGE: ast

LICENSE = since=1997,author=gsf

CCFLAGS = $(CC.OPTIMIZE) $(CC.DLL)

dll 1.0 :LIBRARY: dlfcn.c dllopen.c dllfind.c dllplug.c dll_lib.c \
	dllnext.c dlllook.c dllscan.c dllcheck.c dllerror.c \
	-ldl -ldld

win32.i386-64 :NOOPTIMIZE: dllscan.c

$(INCLUDEDIR) :INSTALLPROTO: dlldefs.h

dlldefs.h :COPY: FEATURE/dll

:: RELEASE

=== debian/changelog ===
ksh (93u+20120801-3.4+deb10u1) buster; urgency=high

  * Fix for CVE-2019-14868: in ksh version 20120801, a flaw was found
    in the way it evaluates certain environment variables. An attacker
    could use this flaw to override or bypass environment restrictions
    to execute shell commands. Services and applications that allow
    remote unauthenticated attackers to provide one of those
    environment variables could allow them to exploit this issue
    remotely. (Closes: #948989)

 -- Anuradha Weeraman <anuradha@debian.org>  Sun, 12 Jul 2020 11:26:07 -0400

ksh (93u+20120801-3.4) unstable; urgency=medium

  [ Boyuan Yang ]
  * debian/menu: Replace menu entry with a .desktop file that only shows under Old menu systems
  * debian/rules: get-orig-source: Add notes about retrieving src
  * debian/watch: Add a watch file to monitor upstream version
  * debian/watch: Fix matching

  [ Aron Xu ]
  * Non-maintainer upload.
  * Fix FTBFS with glibc >= 2.28 by Juhani Numminen (Closes: #915326)

 -- Aron Xu <aron@debian.org>  Fri, 14 Dec 2018 15:26:58 +0800

ksh (93u+20120801-3.3) unstable; urgency=medium

  * Non-maintainer upload.
  * debian/control: Update Vcs-* fields and use git repo under Salsa
    Debian group.
  * debian/patches: Refresh last patch.
  * debian/changelog: Remove trailing spaces.

 -- Boyuan Yang <byang@debian.org>  Fri, 09 Nov 2018 10:52:17 -0500

ksh (93u+20120801-3.2) unstable; urgency=medium

  * Non-maintainer upload.
  * Fix build failures caused by update in glibc (Closes: #887743)

 -- Aron Xu <aron@debian.org>  Mon, 05 Nov 2018 17:46:13 +0800

ksh (93u+20120801-3.1) unstable; urgency=medium

  * Non-maintainer upload.
  * fix postinst with merged /usr using patch from mksh (Closes: #810158)

 -- Christoph Martin <martin@uni-mainz.de>  Wed, 31 May 2017 11:57:56 +0200

ksh (93u+20120801-2) unstable; urgency=medium

  * Adopted package (Closes: #691199)
  * Created alioth git repository and added VCS fields
  * Removed Conflicts clause versus pdksh as it is no longer relevant
  * Marked RELEASE file as an upstream changelog rather than simply doc
  * Added lintian override explaining the absence of a watch file
  * Added patch to correct spelling errors
  * Raised standards version to 3.9.6 - no change
  * Raised compat level and debhelper version to 9
  * Revamped debian/rules and added hardening and reproducibility
  * Added binary format support for compiled scripts (Closes: #687343)
  * Reviewed package description - added note about shcomp
  * Registered with doc-base and added extra documents
  * Moved example.kshrc to /etc/skel/.kshrc
  * Reviewed cleanup-man-title.patch and enabled rksh
  * Small correction to formatting of man page (Closes: #755486)
  * Removed deprecated GREP_OPTIONS from example.kshrc
  * Removed SHLVL increment from example.kshrc as it was doubling increment
  * Rewrote setenv() in example.kshrc (Closes: #792733)
  * Reviewed copyright file and added license-reconcile config
  * Changed default fc editor to ex (Closes: #633524)

 -- Nicholas Bamber <nicholas@periapt.co.uk>  Mon, 02 Nov 2015 15:27:02 +0000

ksh (93u+20120801-1.2) unstable; urgency=medium

  * Non-maintainer upload.
  * Removed extra files that had leaked into debian tarball, mea culpa

 -- Nicholas Bamber <nicholas@periapt.co.uk>  Tue, 27 Oct 2015 08:06:23 +0000

ksh (93u+20120801-1.1) unstable; urgency=medium

  * Non-maintainer upload.
  * Apply patch from bug report to resolve FTBS (Closes: #777930)

 -- Nicholas Bamber <nicholas@periapt.co.uk>  Fri, 16 Oct 2015 07:10:35 +0100

ksh (93u+20120801-1) unstable; urgency=low

  * New upstream release.
  * Support hardening compiler options.
  * Bump to Standards-Version 3.9.4.
  * Includes upstream fix to detect renamed parent directory. (closes: #686149)
  * cd built-in now properly fixed upstream. (Really Closes: #679966)

 -- Oliver Kiddle <okiddle@yahoo.co.uk>  Mon, 07 Jan 2013 16:08:49 +0100

ksh (93u+20120628-1) unstable; urgency=high

  * New upstream release (closes: #679966)

 -- Oliver Kiddle <okiddle@yahoo.co.uk>  Thu, 12 Jul 2012 05:41:59 +0200

=== debian/rules ===
#!/usr/bin/make -f

PACKAGE = ksh

# Variables just for get-orig-source
SRC_VERSION := 93u+20120628
DL_VERSION = 2012-06-28
SRC_DIR = $(PACKAGE)-$(SRC_VERSION)
TARBALL = $(SRC_DIR).tar.gz

ARCH = $(shell bin/package)
INSTALL = install
INSTALL_FILE    = $(INSTALL) -p    -o root -g root  -m  644
INSTALL_PROGRAM = $(INSTALL) -p    -o root -g root  -m  755

DH_VERBOSE=1

# hardening
CCFLAGS:=$(shell dpkg-buildflags --get CFLAGS)
CCFLAGS += $(shell dpkg-buildflags --get CPPFLAGS)
LDFLAGS:=$(shell dpkg-buildflags --get LDFLAGS)
export CCFLAGS
export LDFLAGS

# reproducibility
LC_ALL=C
LANG=C
TZ=/usr/share/zoneinfo/Etc/GMT
export LC_ALL
export LANG
export TZ

%:
	dh $@

override_dh_auto_configure:
	@echo "CCFLAGS=$(CCFLAGS)"
	@echo "LDFLAGS=$(LDFLAGS)"

override_dh_auto_build:	
	bin/package make strip=0

override_dh_auto_install:
	$(INSTALL_PROGRAM) arch/$(ARCH)/bin/ksh debian/ksh/bin/ksh93
	$(INSTALL_PROGRAM) arch/$(ARCH)/bin/shcomp debian/ksh/usr/bin/shcomp
	$(INSTALL_FILE) arch/$(ARCH)/man/man1/sh.1 debian/ksh/usr/share/man/man1/ksh93.1
	$(INSTALL_FILE) arch/$(ARCH)/fun/* debian/ksh/usr/share/ksh/functions
	$(INSTALL_FILE) debian/shcomp.1 debian/ksh/usr/share/man/man1/shcomp.1
	$(INSTALL_FILE) debian/fr-shcomp.1 debian/ksh/usr/share/man/fr/man1/shcomp.1
	$(INSTALL_FILE) -D debian/binfmt_spec debian/ksh/usr/share/binfmts/ksh
	$(INSTALL_FILE) -D debian/example.kshrc debian/ksh/etc/skel/.kshrc
	$(INSTALL_FILE) -D src/cmd/ksh93/PROMO.mm debian/ksh/usr/share/doc/ksh/PROMO
	$(INSTALL_FILE) -D src/cmd/ksh93/builtins.mm debian/ksh/usr/share/doc/ksh/builtins

override_dh_installchangelogs:
	dh_installchangelogs src/cmd/ksh93/RELEASE

clean:
	dh_testdir
	dh_clean
	for i in ignore silent package mamprobe ; do \
		sed -i -e '/^#.\{70\}#/ d'  bin/$$i ; \
	done
	rm -rf arch bin/*.old

get-orig-source:
	@echo 'Old get-orig-source target is no longer usable.'
	@echo 'Please find latest ksh source code at:'
	@echo 'https://github.com/att/ast'
	@exit 1
	rm -rf $(SRC_DIR) $(TARBALL)
	mkdir $(SRC_DIR)
	wget --http-user 'I accept www.opensource.org/licenses/cpl' \
	  --http-password . -O - \
	  http://www.research.att.com/~gsf/download/tgz/INIT.$(DL_VERSION).tgz | \
	  tar xzf - -C $(SRC_DIR)
	wget --http-user 'I accept www.opensource.org/licenses/cpl' \
	  --http-password . -O - \
	  http://www.research.att.com/~gsf/download/tgz/ast-ksh.$(DL_VERSION).tgz | \
	  tar xzf - -C $(SRC_DIR)
	tar cf - $(SRC_DIR) | tardy -group 0 -user 0 - - | gzip -c9 > $(TARBALL)

=== debian/watch ===
version=4
opts="filenamemangle=s%(?:.*?)?(?:ksh)?v?([\da-zA-Z_.-]*)\.tar\.gz%ksh-$1.tar.gz%" \
 https://github.com/att/ast/tags \
 (?:.*?/)?v?(?:ksh)?([\da-zA-Z_.-]*)\.tar\.gz debian uupdate

## ksh 2020.0.0~alpha1

=== debian/changelog ===
ksh (2020.0.0~alpha1-1~exp1) experimental; urgency=medium

  * QA upload.
  * New upstream alpha release (2020.0.0-alpha1).
  * debian: Apply "wrap-and-sort -abst".
  * debian/source.lintian-overrides:
    - Removed, we already have a debian/watch file.
  * debian/rules:
    - get-orig-source: Removed in favour of debian/watch file.
    + Install CHANGELOG.md as upstream changelog.
    - dh_auto_test: Do not abort on failed tests. We
      have 2 failed tests related to HOME directory and the
      fix would not be trivial.
  * debian/control:
    + Bump Standards-Version to 4.3.0.
    + Bump debhelper compat to v12.
    + Switch to meson buildsystem with ninja.
  * debian/patches:
    + Re-evaluate all patches:
      - shell-options.patch: Dropped, upstream unconditionally
        enabled all related features (See CHANGELOG.md)
      - cleanup-man-title.patch: Renamed and refreshed, the new name is
        0001-List-only-supported-names-for-ksh.patch.
      - no-rpath.patch: Dropped, related file no longer exists.
      - ftbs.patch: Dropped, useless.
      - spelling.patch: Refreshed, the new patch name is
        0002-Spelling-mistake-correction-To-keep-lintian-I-happy.patch.
      - bug755486.patch: Dropped, File no longer exists.
      - ed.patch: [TODO] Dropped.
      - 0008-Bug-887743-Fix-build-failures-caused-by-update-in-gl.patch:
        Dropped, applied upstream.
      - bug915326.patch: Dropped, applied upstream.
  * debian/clean: Removed, no longer necessary.
  * debian/copyright:
    - Removed obsolete copyright information.
  * debian/dirs: Remove unnecessary directory creation info.

 -- Boyuan Yang <byang@debian.org>  Fri, 17 May 2019 13:09:44 -0400

=== debian/control ===
--- 
+++ 
@@ -1,16 +1,25 @@
 Source: ksh
 Section: shells
 Priority: optional
-Maintainer: Nicholas Bamber <nicholas@periapt.co.uk>
+Maintainer: Debian QA Group <packages@qa.debian.org>
 Homepage: http://www.kornshell.com/
-Build-Depends: dpkg-dev (>= 1.16.1), debhelper (>= 9)
-Standards-Version: 3.9.6
+Build-Depends:
+ debhelper-compat (= 12),
+ dh-exec,
+ meson,
+ ninja-build,
+ locales-all,
+ procps,
+Standards-Version: 4.3.0
 Vcs-Git: https://salsa.debian.org/debian/ksh.git
 Vcs-Browser: https://salsa.debian.org/debian/ksh
 
 Package: ksh
 Architecture: any
-Depends: ${shlibs:Depends}, ${misc:Depends}, binfmt-support
+Depends:
+ binfmt-support,
+ ${misc:Depends},
+ ${shlibs:Depends},
 Description: Real, AT&T version of the Korn shell
  Ksh is a UNIX command interpreter (shell) that is intended for both
  interactive and shell script use. Its command language is a superset of

=== debian/rules ===
#!/usr/bin/make -f
# -*- makefile -*-
# Uncomment this to turn on verbose mode.
export DH_VERBOSE=1

# see FEATURE AREAS in dpkg-buildflags(1)
export DEB_BUILD_MAINT_OPTIONS = hardening=+all

# see ENVIRONMENT in dpkg-buildflags(1)
# package maintainers to append CFLAGS
#export DEB_CFLAGS_MAINT_APPEND  = -Wall -pedantic
# package maintainers to append LDFLAGS
export DEB_LDFLAGS_MAINT_APPEND = -Wl,--as-needed

# reproducibility
LC_ALL=C
LANG=C
TZ=/usr/share/zoneinfo/Etc/GMT
export LC_ALL
export LANG
export TZ

# provide a fake HOME directory to solve test fails
HOME=$(CURDIR)/debian/fakehome
export HOME

%:
	dh $@ --no-parallel

override_dh_auto_install:
	dh_auto_install
	# Rename /usr/bin/ksh to /usr/bin/ksh93 to keep compatibility
	# with old behaviour as well as alternative system
	mv $(CURDIR)/debian/ksh/usr/bin/ksh $(CURDIR)/debian/ksh/usr/bin/ksh93
	# Also rename the man pages
	mv $(CURDIR)/debian/ksh/usr/share/man/man1/ksh.1 \
	        $(CURDIR)/debian/ksh/usr/share/man/man1/ksh93.1

override_dh_installchangelogs:
	# ChangeLog till 93v is provided in src/cmd/ksh93/RELEASE
	dh_installchangelogs -k CHANGELOG.md

override_dh_missing:
	dh_missing --fail-missing

override_dh_auto_test:
	# Multiple tests fail, skipping for now
	-dh_auto_test
